# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: chat.proto
# plugin: python-betterproto
from dataclasses import dataclass
from datetime import datetime
from typing import AsyncIterator, List, Optional

import betterproto
import grpclib


@dataclass(eq=False, repr=False)
class Message(betterproto.Message):
    sender: "_common__.UserId" = betterproto.message_field(1)
    room_id: "RoomId" = betterproto.message_field(2)
    body: str = betterproto.string_field(3)
    sent_time: datetime = betterproto.message_field(4)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class RoomId(betterproto.Message):
    id: int = betterproto.int32_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class SendResponse(betterproto.Message):
    pass

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LeaveResponse(betterproto.Message):
    pass

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class JoinResponse(betterproto.Message):
    pass

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class JoinEvent(betterproto.Message):
    room_id: "RoomId" = betterproto.message_field(1)
    user_id: "_common__.UserId" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LeaveEvent(betterproto.Message):
    room_id: "RoomId" = betterproto.message_field(1)
    user_id: "_common__.UserId" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class JoinRequest(betterproto.Message):
    room_id: "RoomId" = betterproto.message_field(1)
    user_id: "_common__.UserId" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LeaveRequest(betterproto.Message):
    room_id: "RoomId" = betterproto.message_field(1)
    user_id: "_common__.UserId" = betterproto.message_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class LastMessagesRequest(betterproto.Message):
    room_id: "RoomId" = betterproto.message_field(1)
    count: int = betterproto.int32_field(2)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Rooms(betterproto.Message):
    rooms: List["RoomId"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Event(betterproto.Message):
    login: "JoinEvent" = betterproto.message_field(1, group="event")
    logout: "LeaveEvent" = betterproto.message_field(2, group="event")
    msg: "Message" = betterproto.message_field(3, group="event")

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class RoomRequest(betterproto.Message):
    pass

    def __post_init__(self) -> None:
        super().__post_init__()


@dataclass(eq=False, repr=False)
class Messages(betterproto.Message):
    messages: List["Message"] = betterproto.message_field(1)

    def __post_init__(self) -> None:
        super().__post_init__()


class ChatServiceStub(betterproto.ServiceStub):
    async def send_message(
        self,
        *,
        sender: "_common__.UserId" = None,
        room_id: "RoomId" = None,
        body: str = "",
        sent_time: datetime = None,
    ) -> "SendResponse":
        """Sends a message"""

        request = Message()
        if sender is not None:
            request.sender = sender
        if room_id is not None:
            request.room_id = room_id
        request.body = body
        if sent_time is not None:
            request.sent_time = sent_time

        return await self._unary_unary(
            "/chat.ChatService/SendMessage", request, SendResponse
        )

    async def get_event_stream(self, *, id: int = 0) -> AsyncIterator["Event"]:

        request = _common__.UserId()
        request.id = id

        async for response in self._unary_stream(
            "/chat.ChatService/getEventStream",
            request,
            Event,
        ):
            yield response

    async def join_room(
        self, *, room_id: "RoomId" = None, user_id: "_common__.UserId" = None
    ) -> "JoinResponse":

        request = JoinRequest()
        if room_id is not None:
            request.room_id = room_id
        if user_id is not None:
            request.user_id = user_id

        return await self._unary_unary(
            "/chat.ChatService/JoinRoom", request, JoinResponse
        )

    async def leave_room(
        self, *, room_id: "RoomId" = None, user_id: "_common__.UserId" = None
    ) -> "LeaveResponse":

        request = LeaveRequest()
        if room_id is not None:
            request.room_id = room_id
        if user_id is not None:
            request.user_id = user_id

        return await self._unary_unary(
            "/chat.ChatService/LeaveRoom", request, LeaveResponse
        )

    async def get_rooms_by_user(self, *, id: int = 0) -> "Rooms":

        request = _common__.UserId()
        request.id = id

        return await self._unary_unary(
            "/chat.ChatService/GetRoomsByUser", request, Rooms
        )

    async def get_all_rooms(self) -> "Rooms":

        request = RoomRequest()

        return await self._unary_unary("/chat.ChatService/getAllRooms", request, Rooms)

    async def get_last_messages_by_room(
        self, *, room_id: "RoomId" = None, count: int = 0
    ) -> "Messages":

        request = LastMessagesRequest()
        if room_id is not None:
            request.room_id = room_id
        request.count = count

        return await self._unary_unary(
            "/chat.ChatService/GetLastMessagesByRoom", request, Messages
        )


from .. import common as _common__
